Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestEntry/FrmRequestPrintSelAux.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestEntry/FrmRequestPrintSelAux.cs	(revision 334)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/RequestEntry/FrmRequestPrintSelAux.cs	(revision 335)
@@ -6,6 +6,7 @@
 using System.Drawing;
 using System.Linq;
 using System.Text;
+using System.Threading;
 using System.Threading.Tasks;
 using System.Windows.Forms;
 
@@ -178,40 +179,40 @@
         private void GetInvData()
         {
             IOInvoiceData ioInvData = new IOInvoiceData();
-
-            ArrayList arData = new ArrayList();
-
             try
             {
-                string sql = "SELECT";
-                sql += " InvData.InvoiceNo";
-                sql += " ,InvData.OrderersDivision";
-                sql += " ,InvData.OrderersCode";
-                sql += " ,InvData.RequestMonth";
-                sql += " ,InvData.SeqNo";
-                sql += " ,DATE_FORMAT(InvData.CretateDate, '%Y/%m/%d')";
-                sql += " ,DATE_FORMAT(InvData.RequestDate, '%Y/%m/%d')";
-                sql += " ,InvData.RequestName";
-                sql += " ,InvData.TotalAmount";
-                sql += " ,InvData.TaxAmount";
-                sql += " ,InvData.Comment1";
-                sql += " ,InvData.Comment2";
-                sql += " ,InvData.Comment3";
-                sql += " ,InvData.Comment4";
-                sql += " ,InvData.Comment5";
-                sql += " ,InvData.CompleteFlg";
-                sql += " ,DATE_FORMAT(InvData.EntryDate, '%Y/%m/%d %H:%i:%s')";
-                sql += " ,DATE_FORMAT(InvData.UpdateDate, '%Y/%m/%d %H:%i:%s')";
-                sql += " FROM";
-                sql += " InvoiceData InvData";
-                sql += string.Format(" WHERE InvData.OrderersDivision = {0}", m_nOrderersDivision);
-                sql += string.Format(" AND InvData.OrderersCode = {0} ", m_nOrderersCode);
-                sql += string.Format(" AND InvData.RequestMonth = {0} ", m_nRequestMonth);
-                sql += " AND EXISTS( SELECT * FROM RequestHead ReqHead WHERE ReqHead.InvoiceNo = InvData.InvoiceNo )";
-                sql += " ORDER BY InvData.CretateDate Asc, InvData.SeqNo Asc";
+                ArrayList arData = new ArrayList();
 
+                StringBuilder sql = new StringBuilder();
+                sql.Append("SELECT");
+                sql.Append(" InvData.InvoiceNo");
+                sql.Append(" ,InvData.OrderersDivision");
+                sql.Append(" ,InvData.OrderersCode");
+                sql.Append(" ,InvData.RequestMonth");
+                sql.Append(" ,InvData.SeqNo");
+                sql.Append(" ,DATE_FORMAT(InvData.CretateDate, '%Y/%m/%d')");
+                sql.Append(" ,DATE_FORMAT(InvData.RequestDate, '%Y/%m/%d')");
+                sql.Append(" ,InvData.RequestName");
+                sql.Append(" ,InvData.TotalAmount");
+                sql.Append(" ,InvData.TaxAmount");
+                sql.Append(" ,InvData.Comment1");
+                sql.Append(" ,InvData.Comment2");
+                sql.Append(" ,InvData.Comment3");
+                sql.Append(" ,InvData.Comment4");
+                sql.Append(" ,InvData.Comment5");
+                sql.Append(" ,InvData.CompleteFlg");
+                sql.Append(" ,DATE_FORMAT(InvData.EntryDate, '%Y/%m/%d %H:%i:%s')");
+                sql.Append(" ,DATE_FORMAT(InvData.UpdateDate, '%Y/%m/%d %H:%i:%s')");
+                sql.Append(" FROM");
+                sql.Append(" InvoiceData InvData");
+                sql.AppendFormat(" WHERE InvData.OrderersDivision = {0}", m_nOrderersDivision);
+                sql.AppendFormat(" AND InvData.OrderersCode = {0} ", m_nOrderersCode);
+                sql.AppendFormat(" AND InvData.RequestMonth = {0} ", m_nRequestMonth);
+                sql.Append(" AND EXISTS( SELECT * FROM RequestHead ReqHead WHERE ReqHead.InvoiceNo = InvData.InvoiceNo )");
+                sql.Append(" ORDER BY InvData.CretateDate Asc, InvData.SeqNo Asc");
+
                 // SQL実行
-                if (!ioInvData.ExecuteReader(sql, ref arData, true)) return;
+                if (!ioInvData.ExecuteReader(sql.ToString(), ref arData, true)) return;
 
                 // データセット
                 foreach (object[] objwrk in arData)
@@ -249,14 +250,13 @@
             {
                 List<RequestHead> lstWork = new List<RequestHead>();
 
-                string sql = string.Format(" Where RequestMonth = {0}", m_nRequestMonth);
-                sql += string.Format(" And OrderersDivision = {0}", m_nOrderersDivision);
-                sql += string.Format(" And OrderersCode = {0}", m_nOrderersCode);
-                //sql += string.Format(" And OrderersName = '{0}'", m_strOrderersName);
-                //sql += " And AssignedFlg = 0";
-                sql += " Order by ReqConstructionCode Asc, OrderNo Asc";
+                StringBuilder sql = new StringBuilder();
+                sql.AppendFormat(" Where RequestMonth = {0}", m_nRequestMonth);
+                sql.AppendFormat(" And OrderersDivision = {0}", m_nOrderersDivision);
+                sql.AppendFormat(" And OrderersCode = {0}", m_nOrderersCode);
+                sql.Append(" Order by ReqConstructionCode Asc, OrderNo Asc");
 
-                if (ioReqHead.SelectAction(sql, ref lstWork) == false)
+                if (ioReqHead.SelectAction(sql.ToString(), ref lstWork) == false)
                 {
                     return;
                 }
@@ -591,19 +591,19 @@
             IOInvoiceData ioInvData = new IOInvoiceData();
             IORequestHead ioReqHead = new IORequestHead();
 
-            InvoiceData InvData = null;
+            try
+            {
+                InvoiceData InvData = null;
 
-            ioInvData.connect(); ioInvData.beginTran();
-            ioReqHead.connect(); ioReqHead.beginTran();
+                ioInvData.connect(); ioInvData.beginTran();
+                ioReqHead.connect(); ioReqHead.beginTran();
 
-            try
-            {
                 // 請求書Noが指定されていない場合
                 if (nInvoiceNo == 0)
                 {
                     // 請求書Noの採番
                     nInvoiceNo = ioInvData.NumberingInvoiceNo(m_nRequestMonth, false);
-                    if (nInvoiceNo == -1)
+                    if (nInvoiceNo < 0)
                     {
                         // DBロールバック
                         ioInvData.rollback();
@@ -723,19 +723,17 @@
         /// <returns></returns>
         private bool DeleteInvoiceData(int nInvoiceNo)
         {
-            string sql = "";
-
             IOInvoiceData ioInvData = new IOInvoiceData();
             IORequestHead ioReqHead = new IORequestHead();
-
-            ioInvData.beginTran();
-            ioReqHead.beginTran();
-
             try
             {
+                ioInvData.connect(); ioInvData.beginTran();
+                ioReqHead.connect(); ioReqHead.beginTran();
+
                 // 請求書データの削除
-                sql = string.Format(" Where InvoiceNo = {0}", nInvoiceNo);
-                if (!ioInvData.DeleteAction(sql))
+                StringBuilder sql = new StringBuilder();
+                sql.AppendFormat(" Where InvoiceNo = {0}", nInvoiceNo);
+                if (!ioInvData.DeleteAction(sql.ToString(), false))
                 {
                     ioInvData.rollback();
                     ioReqHead.rollback();
@@ -745,8 +743,9 @@
 
                 List<RequestHead> lstReqHead = new List<RequestHead>();
 
-                sql = string.Format(" Where InvoiceNo = {0}", nInvoiceNo);
-                if (!ioReqHead.SelectAction(sql, ref lstReqHead))
+                sql.Clear();
+                sql.AppendFormat(" Where InvoiceNo = {0}", nInvoiceNo);
+                if (!ioReqHead.SelectAction(sql.ToString(), ref lstReqHead, false))
                 {
                     ioInvData.rollback();
                     ioReqHead.rollback();
@@ -761,13 +760,12 @@
                 }
 
                 // 請求ヘッダを更新
-                if (ioReqHead.UpdateAction(lstReqHead) == false)
+                if (!ioReqHead.UpdateAction(lstReqHead, false))
                 {
                     ioInvData.rollback();
                     ioReqHead.rollback();
 
                     return false;
-
                 }
 
                 ioInvData.commit();
@@ -837,5 +835,427 @@
             }
         }
         #endregion
+
+        #region 印刷実行
+        /// <summary>
+        /// 印刷実行
+        /// </summary>
+        private void EntryPrintProc()
+        {
+            FrmSaveFilePath frm = new FrmSaveFilePath();
+            FrmRequestPrint frmPrint = new FrmRequestPrint();
+            IOInvoiceData ioInvData = new IOInvoiceData();
+            IOConstructionBaseInfo ioInfo = new IOConstructionBaseInfo();
+            IOConstructionProgressDate ioPrgDate = new IOConstructionProgressDate();
+            try
+            {
+                frmPrint.InvoiceNo = m_nInvoiceNo;
+                frmPrint.ExcuteDate = DateTime.Today.Date;
+
+                // 印刷確認画面表示
+                DialogResult drRet = frmPrint.ShowDialog();
+                if (drRet == DialogResult.Cancel) return;
+
+                // 印刷データ取得処理
+                if (!GetPrintData()) return;
+
+                //　日付印刷フラグ
+                m_bDatePrintFlg = frmPrint.DatePrintFlg;
+
+                //　印刷日付
+                m_DatePrintOut = frmPrint.ExcuteDate;
+
+                // EXCEL保存時選択
+                if (drRet == DialogResult.No)
+                {
+                    // 保存先を選択する
+                    frm.SaveType = (int)CommonDefine.SaveFileType.ExcelFile;
+                    //frm.ShowInTaskbar = false;
+                    frm.ShowDialog();
+                    if (frm.EndButton == DialogResult.Cancel) return;
+                    m_SelectSaveExcel = frm.SelectPath;
+                }
+
+                // DBトランザクション開始
+                ioInvData.connect(); ioInvData.beginTran();
+                ioInfo.connect(); ioInfo.beginTran();
+                ioPrgDate.connect(); ioPrgDate.beginTran();
+
+                // 請求書データの反映
+                if(!EntryInvoiceData(ioInvData, frmPrint.CommentData))
+                {
+                    ioInvData.rollback();
+                    ioInfo.rollback();
+                    ioPrgDate.rollback();
+                    return;
+                }
+
+                // 工事基本情報を更新する
+                if(!UpdateConstructionBaseInfo(ioInfo, ioPrgDate))
+                {
+                    ioInvData.rollback();
+                    ioInfo.rollback();
+                    ioPrgDate.rollback();
+                    return;
+                }
+
+                ioInvData.commit();
+                ioInfo.commit();
+                ioPrgDate.commit();
+
+                // 印刷プロセス数取得
+                m_ProcessCount = m_lstReqHead.Count + 5;       // 明細枚数＋ＥＸＣＥＬオブジェクト取得(2)＋表紙(2)＋一覧(1)
+                PrintProgress.Visible = true;
+                PrintProgress.Minimum = 0;
+                PrintProgress.Maximum = m_ProcessCount;
+                PrintProgress.Value = 0;
+                panel1.Update();
+
+                m_Canceled = false;
+                // ボタンの変更
+                PrintButtonVisbleControl(true);
+
+                //印刷を別スレッドで実行する
+                m_ProgressCount = 0;
+
+                // 印刷・保存の判定フラグ
+                object[] obj = new object[1];
+                if (drRet == DialogResult.Yes) obj[0] = true;
+                else obj[0] = false;
+
+                workerThread = new Thread(new ParameterizedThreadStart(PrintMain));
+                workerThread.IsBackground = true;
+                workerThread.Start(obj);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                ioInvData.close(); ioInvData = null;
+                ioInfo.close(); ioInfo = null;
+                ioPrgDate.close(); ioPrgDate = null;
+
+                frmPrint.Dispose(); frmPrint = null;
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
+        #region 印刷データ取得処理
+        /// <summary>
+        /// 印刷データ取得処理
+        /// </summary>
+        /// <returns></returns>
+        private bool GetPrintData()
+        {
+            try
+            {
+                bool bRet = true;
+
+                InvoiceData InvData = new InvoiceData();
+                List<RequestHead> lstReqHead = new List<RequestHead>();
+                // 請求書データの取得
+                if (!GetInvoiceData(ref InvData, ref lstReqHead)) return false;
+
+                // 本工事の工事情報の取得
+                if (!GetMainConstructionBaseInfo(lstReqHead)) return false;
+
+                return bRet;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 請求金額退避エリア
+        /// <summary>
+        /// 請求金額退避エリア
+        /// </summary>
+        private long m_lTotalAmount = 0;    // 合計金額
+        private long m_lTaxAmount = 0;      // 合計税金
+        #endregion
+
+        #region 請求書データの取得
+        /// <summary>
+        /// 請求書データの取得
+        /// </summary>
+        private bool GetInvoiceData(ref InvoiceData InvData, ref List<RequestHead> lstReqHead)
+        {
+            IOInvoiceData ioInvData = new IOInvoiceData();
+            IORequestHead ioReqHead = new IORequestHead();
+            IORequestData ioReqData = new IORequestData();
+
+            try
+            {
+                StringBuilder sql = new StringBuilder();
+
+                // 請求書データの取得
+                sql.Append(ioInvData.CreatePrimarykeyString(m_nInvoiceNo));
+                if (!ioInvData.SelectAction(sql.ToString(), ref InvData)) return false;
+
+                // 請求ヘッダの取得
+                sql.Clear();
+                sql.AppendFormat(" WHERE InvoiceNo = {0} ORDER BY ReqConstructionCode", m_nInvoiceNo);
+                if (!ioReqHead.SelectAction(sql.ToString(), ref lstReqHead)) return false;
+
+                foreach (RequestHead ReqHead in lstReqHead)
+                {
+                    // 請求ヘッダの取得
+                    sql.Clear();
+                    sql.AppendFormat(" WHERE RequestNo = {0} ORDER BY MainConstructionCode", ReqHead.RequestNo);
+                    List<RequestData> lstReqData = new List<RequestData>();
+                    if (!ioReqData.SelectAction(sql.ToString(), ref lstReqData)) return false;
+
+                    m_dicReqData.Add(ReqHead.RequestNo, lstReqData);
+
+                    // 請求金額集計
+                    m_lTotalAmount += ReqHead.RequestTotalAmount;
+                    m_lTaxAmount += ReqHead.TaxAmount;
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+
+                return false;
+            }
+            finally
+            {
+                ioInvData.close(); ioInvData = null;
+                ioReqHead.close(); ioReqHead = null;
+                ioReqData.close(); ioReqData = null;
+            }
+
+        }
+        #endregion
+
+        #region 工事基本情報の追加
+        /// <summary>
+        /// 工事基本情報の追加
+        /// </summary>
+        /// <param name="Info"></param>
+        private void AddConstructionBaseInfoDic(ConstructionBaseInfo Info)
+        {
+            ConstructionBaseInfo wrk = null;
+
+            if (!m_dicConstructionBaseInfo.TryGetValue(Info.ConstructionCode, out wrk))
+            {
+                m_dicConstructionBaseInfo.Add(Info.ConstructionCode, Info);
+            }
+        }
+        #endregion
+
+        #region 工事基本情報の取得
+        /// <summary>
+        /// 工事基本情報の取得
+        /// </summary>
+        private bool GetMainConstructionBaseInfo(List<RequestHead> lstReqHead)
+        {
+            IOConstructionBaseInfo ioInfo = new IOConstructionBaseInfo();
+
+            try
+            {
+                StringBuilder sql = new StringBuilder();
+                foreach (RequestHead ReqHead in lstReqHead)
+                {
+                    sql.Clear();
+                    sql.Append(ioInfo.CreatePrimarykeyString(ReqHead.ReqConstructionCode));
+                    ConstructionBaseInfo info = new ConstructionBaseInfo();
+                    if (!ioInfo.SelectAction(sql.ToString(), ref info)) return false;
+
+                    AddConstructionBaseInfoDic(info);
+                }
+
+                List<int> lstKey = new List<int>(m_dicReqData.Keys);
+                foreach (int nRequestNo in lstKey)
+                {
+                    List<RequestData> lstReqData = null;
+
+                    if (!m_dicReqData.TryGetValue(nRequestNo, out lstReqData)) return false;
+
+                    foreach (RequestData ReqData in lstReqData)
+                    {
+                        sql.Clear();
+                        sql.Append(ioInfo.CreatePrimarykeyString(ReqData.MainConstructionCode));
+                        ConstructionBaseInfo info = new ConstructionBaseInfo();
+                        if (!ioInfo.SelectAction(sql.ToString(), ref info)) return false;
+
+                        AddConstructionBaseInfoDic(info);
+                    }
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ioInfo.close(); ioInfo = null;
+            }
+
+        }
+        #endregion
+
+        #region 請求書データの反映
+        /// <summary>
+        /// 請求書データの反映
+        /// </summary>
+        /// <returns></returns>
+        private bool EntryInvoiceData(IOInvoiceData ioInvData, string[] CommentData)
+        {
+            try
+            {
+                InvoiceData invoiceData = new InvoiceData();
+
+                StringBuilder sql = new StringBuilder();
+                sql.Append(ioInvData.CreatePrimarykeyString(m_nInvoiceNo));
+                if (!ioInvData.SelectAction(sql.ToString(), ref invoiceData, false)) return false;
+
+                invoiceData.TotalAmount = m_lTotalAmount;
+                invoiceData.TaxAmount = m_lTaxAmount;
+                invoiceData.RequestDate = m_DatePrintOut;
+
+                invoiceData.Comment1 = CommentData[0];
+                invoiceData.Comment2 = CommentData[1];
+                invoiceData.Comment3 = CommentData[2];
+                invoiceData.Comment4 = CommentData[3];
+                invoiceData.Comment5 = CommentData[4];
+
+                invoiceData.CompleteFlg = 1;
+
+                return ioInvData.UpdateAction(sql.ToString(), invoiceData, false);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+
+                return false;
+            }
+        }
+
+        #endregion
+
+        #region 工事データ更新
+        /// <summary>
+        /// 工事基本情報を更新する
+        /// </summary>
+        /// <returns></returns>
+        private bool UpdateConstructionBaseInfo(IOConstructionBaseInfo ioInfo
+                                                ,IOConstructionProgressDate ioPrgDate)
+        {
+            try
+            {
+                List<int> lstKeyInfo = new List<int>(m_dicConstructionBaseInfo.Keys);
+                Dictionary<int, int> dicCodeWork = new Dictionary<int, int>();
+
+                StringBuilder sql = new StringBuilder();
+
+                foreach (int nConstructionCode in lstKeyInfo)
+                {
+                    int nOldStatus = 0;
+                    ConstructionBaseInfo Info = null;
+
+                    // 工事基本情報の取得
+                    if (!m_dicConstructionBaseInfo.TryGetValue(nConstructionCode, out Info))
+                    {
+                        ioInfo.rollback();
+                        ioPrgDate.rollback();
+                        return false;
+                    }
+
+                    nOldStatus = Info.ConstructionStatusFlg;
+
+                    // 工事状態が「請求準備」ではない場合は対象外
+                    if (nOldStatus != (int)CommonDefine.StatNumArray.Status9) continue;
+
+                    // 工事基本情報で請求一括でない場合は対象外
+                    if (Info.BillingSplitFlg != (int)ConstructionBaseInfo.BillingSplitFlgDef.AllOnBilling) continue;
+
+                    // 工事状態フラグを「請求確認」に変更
+                    Info.ConstructionStatusFlg = (int)CommonDefine.StatNumArray.Status10;
+
+                    // 工事基本情報を更新
+                    sql.Clear();
+                    sql.Append(ioInfo.CreatePrimarykeyString(nConstructionCode));
+                    if (!ioInfo.UpdateAction(sql.ToString(), Info, false)) return false;
+
+                    // 既にデータが存在しないか一度検索しておく
+                    sql.Clear();
+                    sql.Append(ioPrgDate.CreatePrimarykeyString(nConstructionCode, Info.ConstructionStatusFlg));
+                    List<ConstructionProgressDate> lstPrgDate = new List<ConstructionProgressDate>();
+                    if (!ioPrgDate.SelectAction(sql.ToString(), ref lstPrgDate, false)) return false;
+
+                    // データがある場合は、当該データを削除する
+                    if (lstPrgDate.Count > 0)
+                    {
+                        // 該当データを削除
+                        sql.Clear();
+                        sql.Append(ioPrgDate.CreatePrimarykeyString(nConstructionCode, Info.ConstructionStatusFlg));
+                        if (!ioPrgDate.DeleteAction(sql.ToString(), false)) return false;
+                    }
+
+                    // 案件進捗日付データの構築
+                    ConstructionProgressDate PrgDate = new ConstructionProgressDate();
+
+                    // 案件進捗日付データの設定
+                    PrgDate.ConstructionCode = nConstructionCode;
+                    PrgDate.ConstructionStatusFlg = (int)CommonDefine.StatNumArray.Status10;
+                    PrgDate.PreviousStatusFlg = nOldStatus;
+                    PrgDate.ChangeDate = DateTime.Now;
+                    PrgDate.ChangePersonCode = CommonMotions.LoginUserData.PersonCode;
+
+                    // 案件進捗日付データを挿入
+                    if (!ioPrgDate.InsertAction(PrgDate, false)) return false;
+
+                    // 対象工事が結合（子）工事の場合
+                    if (Info.JoinFlg == (int)ConstructionBaseInfo.JoinFlgDef.JoinChildren)
+                    {
+                        // 結合（親）工事番号の取得
+                        int nParentCode = GetJoinParentConstructionCode(nConstructionCode);
+
+                        int nChildCode = 0;
+
+                        // 親工事番号が登録されていない場合は登録する
+                        if (!dicCodeWork.TryGetValue(nParentCode, out nChildCode))
+                        {
+                            // 結合（親）の工事状態を更新するために工事番号を退避
+                            dicCodeWork.Add(nParentCode, nConstructionCode);
+                        }
+                    }
+                }
+
+                List<int> lstKeyLink = new List<int>(dicCodeWork.Keys);
+
+                foreach (int nParentCode in lstKeyLink)
+                {
+                    int nChildCode = 0;
+
+                    if (dicCodeWork.TryGetValue(nParentCode, out nChildCode))
+                    {
+                        // 結合（親）の工事状態を変更
+                        ClsChangeBaseInfoData.SetParentConstrStatus(ioInfo, nChildCode);
+                    }
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+
+        #endregion
     }
 }
